//-- copyright
// OpenProject is an open source project management software.
// Copyright (C) the OpenProject GmbH
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
// Copyright (C) 2006-2013 Jean-Philippe Lang
// Copyright (C) 2010-2013 the ChiliProject Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// See COPYRIGHT and LICENSE files for more details.
//++

@mixin wp-table--time-values
  display: inline-block
  width: calc(50% - 0.5rem - 1px)

@mixin wp-table--actual-time-values
  text-align: right

@mixin wp-table--placeholder-time-values
  display: inline-block
  width: 100%
  text-align: center

// READ value of display fields in wiki macros

display-field
  & .split-time-field
    white-space: nowrap

    .-separator
      display: inline-block
      width: 1rem
      padding-left: 0.25rem
      padding-right: 0.25rem
      text-align: center

// READ value of edit fields
.inline-edit--display-field
  display: inline-block
  max-width: 100%
  @include text-shortener(false)

  &.-placeholder
    font-style: italic
    display: inline-block
    min-width: 100px
    vertical-align: middle

  // Always render custom options as inline
  // when only one line
  .custom-option
    @include text-shortener(false)

    &:not(.-multiple-lines)
      display: inline
      white-space: nowrap

      // Leave space for the badge
      &:not(:only-child)
        max-width: 90%
        display: inline-block
        vertical-align: middle
        // Inherit from Parent, e.g. strikethrough for baseline comparison
        text-decoration: inherit

        &:first-of-type
          padding-right: 5px

      .badge
        height: 1rem

  &.split-time-field
    display: inline-block
    vertical-align: middle
    white-space: nowrap

    // Table specific styles
    .wp-table--cell-container &
      width: 100%

      .-actual-value,
      .-derived-value
        @include wp-table--time-values

    .-actual-value
      @include wp-table--actual-time-values

    .-separator
      display: inline-block
      width: 1rem
      padding-left: 0.25rem
      padding-right: 0.25rem
      text-align: center

  &.spentTime .time-logging--value
    padding: 0 2px

  &.hierarchy-items
    .path
      & > span
        margin-right: 0.25rem

      & > span:last-child
        margin-right: 0

  &.combinedDate
    .display-field--scheduling-icon
      vertical-align: text-top
      margin-right: 0.25rem

.wp-table--cell-container
  .inline-edit--display-field.-placeholder,
  &.estimatedTime,
  &.remainingTime
    width: 100%

    .-placeholder
      @include wp-table--placeholder-time-values

.wp-table--cell-container .dueDate .display-field--scheduling-icon
  display: none

.wp-table--cell-container
  &.duration,
  &.startDate,
  &.dueDate
    overflow: visible

.wp-table--cell-container.startDate
  padding-left: $work-package--start-date-display-field-padding-left
  position: relative

  .display-field--scheduling-icon
    position: absolute
    left: 4px
    top: 4px

  .-placeholder
    // The special alignment of placeholders requires a special alignment of the icon
    .display-field--scheduling-icon
      top: 6px

// Sums in wp table
.wp-table--sum-container.split-time-field
  .-actual-value
    @include wp-table--time-values
    @include wp-table--actual-time-values


// Editable fields cursor
.inline-edit--display-field.-editable
  cursor: text
  border-color: transparent
  border-style: solid
  border-radius: 2px
  border-width: 1px
  overflow-wrap: anywhere
  word-break: normal

  &:hover,
  &:focus
    border-color: var(--borderColor-default)

    &.-multiline
      white-space: inherit

// Mark focused, non-editable read-values
// Special handling for spent time field, as the logTime link should not be highlighted
.inline-edit--display-field:not(.id):not(.spentTime).-read-only,
.inline-edit--display-field.spentTime.-read-only .time-logging--value_empty
  cursor: not-allowed

  &:focus, &:hover
    color: var(--fgColor-disabled)
    background: var(--bgColor-disabled)

op-editable-attribute-field
  width: 100%

  .-minimal &
    width: initial
